<template>
    <div class="sidebar-block">
        <div class="sidebar-title">Standings</div>
        <div class="sidebar-content" v-if="!loading && standings">
            <div class="sidebar-standings">
                <template v-if="standings && !Array.isArray(standings) && standings.team">
                    <div class="head">
                        <div class="n">#</div>
                        <div class="team">Team</div>
                        <div class="mp">MP</div>
                        <div class="pts">Pts</div>
                    </div>
                    <div class="rows">
                        <div
                            v-for="(item, idx) in standings.team"
                            :key="idx"
                            :class="[
                            'row',
                            `row-${item['@status']}`
                        ]">
                            <div class="team">
                                <div :class="[`icon-football`, `icon`]"  :style="{ backgroundImage: teamLogo(item) }"></div>
                                <div class="text">{{ item['@name'] }}</div>
                            </div>
                            <div class="mp">{{ item.overall['@gp'] }}</div>
                            <div class="pts">{{ item.total['@p'] }}</div>
                        </div>
                    </div>
                </template>

                <div v-if="standings && Array.isArray(standings)" v-for="(group, groupIdx) in standings" :key="groupIdx">
                    <div class="head head-group-name">
                        <div class="team group-name">{{ group['@group'] }}</div>
                    </div>
                    <div class="head">
                        <div class="n">#</div>
                        <div class="team">Team</div>
                        <div class="mp">MP</div>
                        <div class="pts">Pts</div>
                    </div>
                    <div class="rows">
                        <div
                            v-for="(item, idx) in group.team"
                            :key="idx"
                            :class="[
                            'row',
                            `row-${item['@status']}`
                        ]">
                            <div class="team">
                                <div :class="[`icon-football`, `icon`]"  :style="{ backgroundImage: teamLogo(item) }"></div>
                                <div class="text">{{ item['@name'] }}</div>
                            </div>
                            <div class="mp">{{ item.overall['@gp'] }}</div>
                            <div class="pts">{{ item.total['@p'] }}</div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <horizontal-loader v-else-if="loading" />
        <div class="no-standings c-white" v-else>No standings data available for this league</div>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex'
import HorizontalLoader from '../HorizontalLoader'
import { Fragment } from 'vue-fragment'
export default {
    name: 'Standings',
    components: { HorizontalLoader, Fragment },
    data() {
        return {
            loading: true
        }
    },
    computed: {
        ...mapGetters(['standings','standingsTeamsLogos'])
    },
    methods: {
        ...mapActions(['fetchStandings']),
        async fetchData() {
            await this.fetchStandings(this.$route.params.leagueId)
        },
        teamLogo(item) {
            let img = this.standingsTeamsLogos.find((element,index)=>{
                return (typeof element[item['@id']] !=='undefined')
             });
            if(typeof img !=='undefined' ){
                if(!(Object.values(img)[0]['participant_image']===null)){
                    return `url('${window.location.origin}/storage/${Object.values(img)[0]['participant_image']}')`
                }
                return `url('${window.location.origin}/storage/${Object.values(img)[0]['image']}')`
            }
            return  `url('${window.location.origin}/img/team_placeholder.svg')`;
        },
    },
    mounted() {
        this.fetchData().finally(() => {
            this.loading = false;
            this.$forceUpdate()
        })
    },
    watch: {
        '$route.params.leagueId': function() {
            this.loading = true
            this.fetchData().finally(() => {
                this.loading = false
                this.$forceUpdate()
            })
        }
    }
}
</script>

<style scoped>
    .no-standings {
        padding: 8px 12px;
    }
    .head-group-name {
        margin-top: 24px;
    }
</style>
